// TvRock  tvrock.sch ϊĂڂJ_[ɃAbv[hc[
//
//  cscript syobocalUploader.js <user> <pass> [epgurl] [slot]
//
//   <user>        ڂJ_[UserID
//   <pass>        ڂJ_[̃pX[h
//   [epgurl]      TvRockURL
//                 ) http://recserver:8969/nobody/
//   [slot]        0`3̐l(w̏ꍇ0)
//

var _userAgent = 'tvrockSchUploader/1.1.0';
var _uploadUrl = 'http://cal.syoboi.jp/sch_upload';
 
main(WScript.Arguments);

function main(args) {
	if (args.length < 2) {
		WScript.Echo('tvrockSchUploader.js <user> <pass> [epgurl]');
	}
	else {
		var items = loadSchFile('tvrock.sch');
		var sch_data = formatItems(items);
		var sch_epgurl = (args.length > 2 ? args(2) : '');
		var slot = (args.length > 3 ? args(3) : 0);
		
		upload(args(0), args(1), sch_data, sch_epgurl, slot);
	}
}

// Abv[hf[^̌`ɕϊ(tsv)
function formatItems(items)
{
	var text = '';
	
	for (var j=0; j<items.length; j++) {
		var item = items[j];
		text += [
			item.START,
			item.END,
			item.DEV,
			tsvEscape(item.TITLE),
			tsvEscape(item.STATION),
			tsvEscape(item.SUBTITLE),
			item.OFFSET,
			item.UNIQID
		].join("\t")+"\n";
	}
	// WScript.Echo(text.replace(/\t/g,' ')); WScript.Quit(0);
	return text;
	
}

function tsvEscape(text)
{
	return text.replace("\t", " ");
}

// Abv[h
function upload(user, pass, sch_data, sch_epgurl, slot)
{
	var http = new ActiveXObject('MSXML2.XMLHTTP');
	
	http.Open('POST', _uploadUrl+'?slot='+slot, false, user, pass);
	http.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
	http.setRequestHeader('User-agent', _userAgent);
	http.onreadystatechange = function(){
		if (http.readyState == 4) {
			if (http.status == 200) {
				WScript.Echo(http.responseText);
			}
			else {
				WScript.Echo('UPLOAD ERROR: '+http.status);
			}
		}
	};
	http.send(
		'data='+encodeURIComponent(sch_data)
		+'&epgurl='+encodeURIComponent(
			(sch_epgurl != '' ? sch_epgurl+'reg?i={XID}' : '')
		)
	);
}

// tvrock.sch ǂݍŔzԂ
function loadSchFile(path)
{
	var fso = new ActiveXObject('Scripting.FileSystemObject');
	var ts = fso.OpenTextFile(path, 1);

	var devMap = ['Cap','Ex1','Ex2','Ex3','Ex4','T1','T2','T3','T4','T5','T6','T7','T8','R'];
	
	var items = [];
	items.add = function(item) {
		if (item.VALIDATE != '0') {
			item.DEV = devMap[item.DEVNO];
			item.OFFSET = item.START - item.STBK;
			//WScript.Echo([item.START, item.END, item.DEV, item.TITLE, item.STATION, item.SUBTITLE]);

			this.push(item);
		}
	}
	
	var number = null;
	var item = {};
	while (!ts.AtEndOfLine) {
		var cps = ts.ReadLine().match(/^(\d+) (\S+) (.*)$/);
		if (cps) {
			if (number != cps[1]) {
				if (number) {
					items.add(item);
				}
				number = cps[1];
				item = {idx:number};
			}
			if (cps[2].match(/^(TITLE|STATION|START|STBK|END|DEVNO|SUBTITLE|VALIDATE|UNIQID)$/)) {
				item[cps[2]] = cps[3];
			}
		}
	}
	if (number) {
		items.add(item);
	}

	return items;
}
